%define pkg       squid
%define ver       2.7.STABLE9
%define maj       %(echo %{ver} | cut -d'.' -f1)
%define min       %(echo %{ver} | cut -d'.' -f2)
%define pkgid     %{maj}
%define pkgstr    %{pkg}%{pkgid}

%define sel_modn  selinux-policy-addon
%define sel_modv  0.2.3


Summary:          The Squid proxy caching server
Name:             %{pkgstr}
Version:          %{ver}
Release:          2%{?dist}%{?pext}
License:          GPL
Group:            System Environment/Daemons
Source0:          http://www.squid-cache.org/Versions/v%{maj}/%{maj}.%{min}/%{pkg}-%{ver}.tar.bz2
Source1:          %{pkg}.init
Source2:          %{pkg}.logrotate
Source3:          %{pkg}.sysconfig
Source4:          %{pkg}.conf
Source5:          %{pkg}.pam
Patch0:           %{pkg}-2.7.9-paths.patch
Patch1:           %{pkg}-2.6.16-config.patch
Patch10:          http://www.squid-cache.org/Versions/v2/2.7/changesets/%{pkg}-2.7-12697.patch
Patch11:          http://www.squid-cache.org/Versions/v2/2.7/changesets/%{pkg}-2.7-12711.patch
Patch12:          http://www.squid-cache.org/Versions/v2/2.7/changesets/%{pkg}-2.7-12714.patch
URL:              http://www.squid-cache.org/
Buildroot:        %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Vendor:           Duane Wessels <wessels@squid-cache.org>
Requires(pre):    /usr/sbin/groupadd /usr/sbin/useradd
Requires(post):   /sbin/chkconfig
Requires(preun):  /sbin/chkconfig /sbin/service
Requires(postun): /sbin/service
Conflicts:        %{pkg} %{pkg}3
BuildRequires:    cyrus-sasl-devel db4-devel krb5-devel
BuildRequires:    openldap-devel openssl-devel pam-devel
BuildRequires:    pkgconfig

%description
Squid is a high-performance proxy caching server for Web clients, supporting
FTP, Gopher and HTTP data objects. Unlike traditional caching software, Squid
handles all requests in a single, non-blocking, I/O-driven process. It keeps
metadata and especially hot objects cached in RAM, caches DNS lookups, supports
non-blocking DNS lookups, and implements negative caching of failed requests.


%package          selinux
Summary:          SELinux support for Squid
Group:            System Environment/Base
Requires:         %{name} = %{version}-%{release}
Requires:         %{sel_modn} >= %{sel_modv}
Requires(post):   /sbin/restorecon %{_sbindir}/selinuxenabled /sbin/fixfiles

%description      selinux
This package enables Squid to work with SELinux.


%prep
%setup -q -n %{pkg}-%{ver}

# Local patches
%patch0 -p1
%patch1 -p1

# Upstream patches
%patch10 -p1
%patch11 -p1
%patch12 -p1

# Fix path to Perl
for FILE in `find . -type f -name "*.pl" -exec fgrep -l "/bin/perl" {} \;`; do
  %{__perl} -i -pe 's+(/.*)?/bin/perl+%{__perl}+g' ${FILE}
done

# Prepare docs
%{__mkdir_p} doc/helpers/basic/{DB,LDAP,MSNT,SASL,SMB,multi,radius}
%{__mkdir_p} doc/helpers/external/{ip_user,ldap_group,unix_group}
%{__mkdir_p} doc/helpers/negotiate/kerberos
%{__mkdir_p} doc/helpers/ntlm/no_check

%{__cp} helpers/basic_auth/DB/passwd.sql  doc/helpers/basic/DB
%{__cp} helpers/basic_auth/LDAP/README    doc/helpers/basic/LDAP
%{__cp} helpers/basic_auth/MSNT/COPYING*  doc/helpers/basic/MSNT
%{__cp} helpers/basic_auth/MSNT/README*   doc/helpers/basic/MSNT
%{__cp} helpers/basic_auth/SASL/README    doc/helpers/basic/SASL
%{__cp} helpers/basic_auth/SASL/*.conf    doc/helpers/basic/SASL
%{__cp} helpers/basic_auth/SMB/COPYING*   doc/helpers/basic/SMB
%{__cp} helpers/basic_auth/SMB/ChangeLog  doc/helpers/basic/SMB
%{__cp} helpers/basic_auth/SMB/README     doc/helpers/basic/SMB
%{__cp} helpers/basic_auth/mult*/README*  doc/helpers/basic/multi
%{__cp} helpers/basic_auth/squid*/README  doc/helpers/basic/radius

%{__cp} helpers/external*/ip_user/README  doc/helpers/external/ip_user
%{__cp} helpers/external*/ip_user/license doc/helpers/external/ip_user
%{__cp} helpers/external*/ip_user/*.conf  doc/helpers/external/ip_user
%{__cp} helpers/external*/ldap*/ChangeLog doc/helpers/external/ldap_group
%{__cp} helpers/external*/ldap*/README    doc/helpers/external/ldap_group
%{__cp} helpers/external*/unix*/README    doc/helpers/external/unix_group

%{__cp} helpers/negotiat*/squid*/COPYING  doc/helpers/negotiate/kerberos
%{__cp} helpers/negotiat*/squid*/readme.* doc/helpers/negotiate/kerberos

%{__cp} helpers/ntlm*/no_check/README*    doc/helpers/ntlm/no_check/README


%build
%configure \
	CFLAGS="${CFLAGS} -DOPENSSL_NO_KRB5"                    \
	--sysconfdir=%{_sysconfdir}/%{pkg}                      \
	--libexecdir=%{_libexecdir}/%{pkg}                      \
	--datadir=%{_datadir}/%{pkg}                            \
	--enable-async-io=64                                    \
	--enable-storeio="aufs,coss,diskd,null,ufs"             \
	--enable-removal-policies="heap,lru"                    \
	--enable-icmp                                           \
	--enable-delay-pools                                    \
	--enable-useragent-log                                  \
	--enable-referer-log                                    \
	--enable-kill-parent-hack                               \
	--enable-forward-log                                    \
	--enable-multicast-miss                                 \
	--enable-snmp                                           \
	--enable-arp-acl                                        \
	--enable-htcp                                           \
	--enable-ssl                                            \
	--enable-forw-via-db                                    \
	--enable-cache-digests                                  \
	--enable-coss-aio-ops                                   \
	--enable-linux-netfilter                                \
	--enable-large-cache-files                              \
	--disable-ident-lookups                                 \
	--enable-auth="basic,digest,negotiate,ntlm"             \
	--enable-basic-auth-helpers="DB,LDAP,MSNT,NCSA,PAM,SASL,SMB,getpwnam,multi-domain-NTLM,squid_radius_auth" \
	--enable-ntlm-auth-helpers="SMB,fakeauth,no_check"      \
	--enable-ntlm-fail-open                                 \
	--enable-digest-auth-helpers="eDirectory,ldap,password" \
	--enable-negotiate-auth-helpers="squid_kerb_auth"       \
	--enable-external-acl-helpers="ip_user,ldap_group,session,unix_group,wbinfo_group" \
	--enable-stacktraces                                    \
	--enable-x-accelerator-vary                             \
	--enable-follow-x-forwarded-for                         \
	--with-pthreads                                         \
	--with-aio                                              \
	--with-dl                                               \
	--with-openssl=%{_prefix}                               \
	--with-large-files                                      \
	--with-maxfd=32768

%{__make} #%{?_smp_mflags}


%install
[ -n "${RPM_BUILD_ROOT}" -a "${RPM_BUILD_ROOT}" != "/" ] && %{__rm} -rf ${RPM_BUILD_ROOT}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_initrddir}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_sysconfdir}/{httpd/conf.d,logrotate.d,pam.d,sysconfig}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_prefix}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_localstatedir}/{cache,log}/%{pkg}

%{__make} \
	DESTDIR=${RPM_BUILD_ROOT} \
	install

%{__install} -m 0755 %{SOURCE1} ${RPM_BUILD_ROOT}%{_initrddir}/%{pkg}
%{__install} -m 0644 %{SOURCE2} ${RPM_BUILD_ROOT}%{_sysconfdir}/logrotate.d/%{pkg}
%{__install} -m 0644 %{SOURCE3} ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig/%{pkg}

%{__install} -m 0644 %{SOURCE4} ${RPM_BUILD_ROOT}%{_sysconfdir}/httpd/conf.d
%{__install} -m 0644 %{SOURCE5} ${RPM_BUILD_ROOT}%{_sysconfdir}/pam.d/%{pkg}

%{__chmod}   u+s                ${RPM_BUILD_ROOT}%{_libexecdir}/%{pkg}/pinger

%{__rm}      -f                 ${RPM_BUILD_ROOT}%{_bindir}/Run{Accel,Cache}


%pre
if ! getent group  %{pkg} >/dev/null 2>&1; then
  /usr/sbin/groupadd -r -g 23 %{pkg}
fi
if ! getent passwd %{pkg} >/dev/null 2>&1; then
  /usr/sbin/useradd  -r -u 23 -g %{pkg}   \
	-d %{_localstatedir}/cache/%{pkg} \
	-c "SQUID Service user"           \
	-s /sbin/nologin %{pkg}
fi
exit 0			# Always pass


%post
/sbin/chkconfig --add %{pkg}

%post selinux
if /usr/sbin/selinuxenabled && [ -e /selinux/policyvers ]; then
  /sbin/fixfiles   -R %{name} restore
# /sbin/restorecon -R %{_localstatedir}/cache/%{pkg}
  /sbin/restorecon -R %{_localstatedir}/log/%{pkg}
fi


%preun
if [ $1 -eq 0 ]; then	# Remove
  /sbin/service %{pkg} stop >/dev/null 2>&1
  /sbin/chkconfig --del %{pkg}
fi


%postun
if [ $1 -ge 1 ]; then	# Upgrade
  /sbin/service %{pkg} condrestart >/dev/null 2>&1 || :
fi


%clean
[ -n "${RPM_BUILD_ROOT}" -a "${RPM_BUILD_ROOT}" != "/" ] && %{__rm} -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,root)
%doc CONTRIBUTORS COPY* CREDITS ChangeLog INSTALL QUICK*
%doc README RELEASENOTES* SPONSORS doc/*.txt doc/helpers
%{_initrddir}/%{pkg}
%config(noreplace) %{_sysconfdir}/logrotate.d/%{pkg}
%config(noreplace) %{_sysconfdir}/sysconfig/%{pkg}
%config(noreplace) %{_sysconfdir}/httpd/conf.d/%{pkg}.conf
%config(noreplace) %{_sysconfdir}/pam.d/%{pkg}
%attr(750,root,%{pkg}) %dir %{_sysconfdir}/%{pkg}
%attr(640,root,%{pkg}) %config(noreplace) %{_sysconfdir}/%{pkg}/*.conf
%{_sysconfdir}/%{pkg}/*.default
%{_bindir}/cossdump
%{_bindir}/squidclient
%{_libexecdir}/%{pkg}
%{_sbindir}/%{pkg}
%{_datadir}/%{pkg}
%{_mandir}/man8/*.8*
%attr(750,%{pkg},%{pkg}) %dir %{_localstatedir}/cache/%{pkg}
%attr(750,%{pkg},%{pkg}) %dir %{_localstatedir}/log/%{pkg}

%files selinux
%defattr(-,root,root)


%changelog
* Wed Feb 22 2017 Peter Pramberger <peterpramb@member.fsf.org> - 2.7.STABLE9-2
- Do not forcefully disable HTTP violations (George Nikandrov)
- Added final upstream patches

* Mon May 17 2010 Peter Pramberger <peterpramb@member.fsf.org> - 2.7.STABLE9-1
- New version (2.7.STABLE9)

* Sun Sep 27 2009 Peter Pramberger <peterpramb@member.fsf.org> - 2.7.STABLE7-1
- New version (2.7.STABLE7)

* Sat Feb 14 2009 Peter Pramberger <peterpramb@member.fsf.org> - 2.7.STABLE6-1
- Initial build
